// ----------------------------------------------------------------------------
// J.Kleimola and P.McGlynn, "Streamlining the Flow of Open Sound Control"
// (submitted to SMC-2011)
// ----------------------------------------------------------------------------

import oscP5.*;
import netP5.*;

OscP5 oscP5;
NetAddress dest;
OscStreamliner osc2;

void setup()
{
  size(400,400);
  frameRate(25);
  dest = new NetAddress("127.0.0.1", 8000);
  oscP5 = new OscP5(this, 8000);
  
  osc2 = new OscStreamliner("map.txt");
}

void draw()
{
  background(0);  
}

void mousePressed()
{
  OscMessage2 msg = new OscMessage2("/one");  
  msg.add(mouseX % 4);
  oscP5.send(msg, dest);
}

// -- incoming OSC messages are routed here
void oscEvent(OscMessage msg)
{
  int iaddr = msg.get(0).intValue();
  int mx = msg.get(1).intValue();
  String address = osc2.address(iaddr);
  println(msg.addrPattern() + " " + msg.typetag() + " " + iaddr + " " + mx + " " + address);
}

